/*
 * JBoss, the open source webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

package org.jboss.ejb3.test.localcall;

import javax.ejb.Remote;
import javax.ejb.Local;
import javax.naming.InitialContext;

import org.jboss.annotation.ejb.Service;

/**
 *
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.2.2.5 $
 */
@Service
@Remote(ServiceRemote.class)
@Local(ServiceLocal.class)
public class ServiceBean implements ServiceLocal, ServiceRemote
{
   public void test()
   {
      
   }
   
   public void testLocal()throws Exception
   {
      InitialContext ctx = new InitialContext();
      StatefulLocal stateful1 = (StatefulLocal)ctx.lookup(StatefulLocal.class.getName());
      StatefulLocal stateful2 = (StatefulLocal)ctx.lookup(StatefulLocal.class.getName());
      
      StatefulClustered statefulClustered1 = (StatefulClustered)ctx.lookup(StatefulClustered.class.getName());
      StatefulClustered statefulClustered2 = (StatefulClustered)ctx.lookup(StatefulClustered.class.getName());
      
      StatelessLocal stateless1 = (StatelessLocal)ctx.lookup(StatelessLocal.class.getName());
      StatelessLocal stateless2 = (StatelessLocal)ctx.lookup(StatelessLocal.class.getName());
      
      StatelessClustered statelessClustered1 = (StatelessClustered)ctx.lookup(StatelessClustered.class.getName());
      StatelessClustered statelessClustered2 = (StatelessClustered)ctx.lookup(StatelessClustered.class.getName());
      
      ServiceLocal service1 = (ServiceLocal)ctx.lookup(ServiceLocal.class.getName());
      ServiceLocal service2 = (ServiceLocal)ctx.lookup(ServiceLocal.class.getName());
      
      stateful1.test();
      stateful2.test();
      statefulClustered1.test();
      statefulClustered2.test();
      stateless1.test();
      stateless2.test();
      statelessClustered1.test();
      statelessClustered2.test();
      service1.test();
      service2.test();

      assertFalse(stateful1.hashCode() ==  stateful2.hashCode());
      assertFalse(statefulClustered1.hashCode() == statefulClustered2.hashCode());
      assertTrue(stateless1.hashCode() == stateless2.hashCode());
      assertTrue(statelessClustered1.hashCode() == statelessClustered2.hashCode());
      assertTrue(service1.hashCode() == service2.hashCode());
      
      assertFalse(stateful1.equals(stateful2));
      assertFalse(statefulClustered1.equals(statefulClustered2));
      assertTrue(stateless1.equals(stateless2));
      assertTrue(statelessClustered1.equals(statelessClustered2));
      assertTrue(service1.equals(service2));
   }
   
   private void assertFalse(boolean b)
   {
      if (b)
      {
         throw new RuntimeException("Assertion failed!");
      }
   }

   private void assertTrue(boolean b)
   {
      if (!b)
      {
         throw new RuntimeException("Assertion failed!");
      }
   }
   
}
